#ifndef __INCHANNELS_H
#define __INCHANNELS_H

#include "generic.h"

class Mp3Channel {
private:

  int spawn();

public:

  Mp3Channel();
  ~Mp3Channel();

  short gotin[BUF_SIZE];
  int sample_rate; /* must be setted when the channel is created */

  int stream[2];
  pid_t pid;
  short *inbuf; /* global inbuf for raw input - shared by all channels */
  char *name;
  float volume;
  float speed;
  int rate;
  int channels;
  bool end;
  bool on;
  char playlist[MAX_PLAYLIST_ENTRY][MAX_PATH_SIZE];
  int playlist_len;

  /* this must be setted if dsp is opened to let close the fd
     for the forked mpg123 */
  int *dsp;
  
  void start(int plpos);
  void stop();
  void ends();

  unsigned int get_audio();
  void get_playlist(char *plfile);
};

#endif
