#ifndef __JMIXER_H
#define __JMIXER_H

#include <unistd.h>
#include <stdlib.h>

#include "generic.h"
#include "inchannels.h"
#include "outchannels.h"
#include "libsync/synchronous.h"

struct livein {
  short inbuf[BUF_SIZE];
  int rate;
  int channels;
  bool on;
};

class Stream_mixer: public LTI::Object {

private:

  short audio_buffer[BUF_SIZE];
  int process_buffer[BUF_SIZE];
  short inbuf[BUF_SIZE*40];

  int dsp;
  bool fullduplex;
  
  struct livein live_channel;
  
  void close_soundcard();

  unsigned int get_livein();
  
public:
  Stream_mixer();

  void run();
  
  bool open_soundcard();
  bool set_icecast(char *ip, int port, char *pass, char *mountpoint, int bps);
  void stop_icecast();
  void play_chunks();
  void resume_channel(int ch);
  void pause_channel(int ch);
  void stop_channel(int ch);
  void set_channel(int ch, int playlist_pos);
  void set_volume(int ch, float vol);
  void set_speed(int ch, float speed);
  void dump_status();
  bool set_live(bool stat);
  void set_playlist(int ch, char *pl);

  Mp3Channel mp3ch[MAX_CHANNELS];
  IcecastOut ice;

  /* this is for the libsync - registering synchronized method's ids */
  static const int id_set_channel = 1;
  static const int id_stop_channel = 2;
  static const int id_pause_channel = 3;
  static const int id_resume_channel = 4;
  static const int id_set_volume = 5;
  static const int id_set_speed = 6;
  static const int id_dump_status = 7;
  static const int id_set_live = 8;
  static const int id_set_playlist = 9;
  static const int id_set_icecast = 10;
  static const int id_stop_icecast = 11;

  bool dspout;
  bool icecastout;
  bool quit;

  int *client;

  ~Stream_mixer();
};

#endif
